import random
import sys
# we generate #s samples for each #e-edge and #n nodes pyramid graph.
#n is node number. 
#e is the edge number.
#s is how many sample for each edge.
n=int(sys.argv[1])
e=int(sys.argv[2])
s=int(sys.argv[3])
'''
n=300
delete_edges=range(10,11)
samples=range(1,2)
for e in delete_edges:
	for s in samples:
'''
with open('./inst/inst'+str(n)+"_"+str(e)+"_"+str(s),'w') as f:

	#calc num of layers:
	layers=0
	while True:
		if layers*(layers+1)/2<n:
			layers+=1
		else :
			break
	layers -=1
	#print layers
	
	#The # of node is < n, since we have pyramid structures.
	numberOfnode=layers*(layers+1)/2



	#write n nodes.
	for i in range(1,numberOfnode+1):
		f.write('node('+str(i)+').\n')

	#generate structured pyramid graph
	dic={}
	#
	for layer in range(1,layers+1):
		# for each layer, calculate all the nodes above it.
		aboveNodes=(layer-1)*layer/2
		for noderInLayer in range(1,layer+1):
			currtNode=aboveNodes+noderInLayer
			#1. for each layer, generate bi-direction edges
			if not noderInLayer==layer:
				key=str(currtNode)+','+str(currtNode+1)
				key2=str(currtNode+1)+','+str(currtNode)
				dic[key]=1
				dic[key2]=1
			#2. add children bi-direction edges	
			if not layer == layers:
				#left child
				key=str(currtNode)+','+str(currtNode+layer)			
				key2=str(currtNode+layer)+','+str(currtNode)
				dic[key]=1
				dic[key2]=1
				#right child
				key=str(currtNode)+','+str(currtNode+layer+1)			
				key2=str(currtNode+layer+1)+','+str(currtNode)
				dic[key]=1
				dic[key2]=1				
	
	#print len(dic)
	#3. delete #delete_edges edges.
	numberOfEdgeDlt=0
	while True:
		randlist=random.sample(range(1,numberOfnode+1),2)
		if randlist[0]!=randlist[1]:
			key=str(randlist[0])+','+str(randlist[1])
			if key in dic:
				del dic[key]
				numberOfEdgeDlt +=1
			if numberOfEdgeDlt==e:
				break
			if len(dic)==0:
				break

	sortdic=sorted([k for k in dic])
	#write keys in the file;
	#only key matters.
	for i in sortdic:
		f.write('link('+i+').\n')
	#print len(dic)
